/***************************************************************************
 *
 * Copyright (C) 2002 International Business Machines
 * All rights reserved.
 *
 * This file is the header file for the liblgm.so interface library to
 * Myricom's GM library.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. The name of the author may not be used to endorse or promote products
 *     derived from this software without specific prior written
 *     permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************** */
/* $Id: lgm.h,v 1.1 2002/01/20 15:14:12 blackmor Exp $
 *
 *
 * $Log: lgm.h,v $
 * Revision 1.1  2002/01/20 15:14:12  blackmor
 * Open source interface to the Myricom GM library. To be checked in for
 * post emperor release.
 *
 */

typedef void (lapi_gm_updatebuf_t)(void *ptr, void *buf);
void gm_lapi_send(void *bufi, int count, int taskid, void *callback);
void lapi_provide_buf(void *bufc);
void lapi_gm_event_loop(pthread_mutex_t *dev_lck, lapi_gm_updatebuf_t *cb, void *cbp);
void lapi_reset_alarm(int time, void *callback, void *param);
void lapi_set_alarm(int time, void *callback, void *param);
void lapi_gm_finish_gm();
int lapi_gm_open();
void lapi_gm_resume(void *p, int node_id, void *callback, void *context);
int lapi_gm_get_node_id(int *id);
void lapi_gm_start_alarm();
void lapi_gm_free_buf(void *buf);
int get_send_tokens();
int get_recv_tokens();
void *get_gm_dma_mem(int count);
void lapi_set_acceptable_sizes(int high_sizes, int low_sizes);
